/*
CVE Services API

The CVE Services API supports automation tooling for the CVE Program. Credentials are     required for most service endpoints. Representatives of     <a href='https://www.cve.org/ProgramOrganization/CNAs'>CVE Numbering Authorities (CNAs)</a> should     use one of the methods below to obtain credentials:    <ul><li>If your organization already has an Organizational Administrator (OA) account for the CVE     Services, ask your admin for credentials</li>     <li>Contact your Root (<a href='https://www.cve.org/PartnerInformation/ListofPartners/partner/Google'>Google</a>,     <a href='https://www.cve.org/PartnerInformation/ListofPartners/partner/INCIBE'>INCIBE</a>,     <a href='https://www.cve.org/PartnerInformation/ListofPartners/partner/jpcert'>JPCERT/CC</a>, or     <a href='https://www.cve.org/PartnerInformation/ListofPartners/partner/redhat'>Red Hat</a>) or     Top-Level Root (<a href='https://www.cve.org/PartnerInformation/ListofPartners/partner/icscert'>CISA ICS</a>     or <a href='https://www.cve.org/PartnerInformation/ListofPartners/partner/mitre'>MITRE</a>) to request credentials     </ul>     <p>CVE data is to be in the JSON 5.0 CVE Record format. Details of the JSON 5.0 schema are     located <a href='https://github.com/CVEProject/cve-schema/tree/master/schema/v5.0' target='_blank'>here</a>.</p>    <a href='https://cveform.mitre.org/' class='link' target='_blank'>Contact the CVE Services team</a>

API version: 2.1.4
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package cveapi

import (
	"encoding/json"
)

// checks if the ListUsersResponseUsersInnerName type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &ListUsersResponseUsersInnerName{}

// ListUsersResponseUsersInnerName struct for ListUsersResponseUsersInnerName
type ListUsersResponseUsersInnerName struct {
	// The first name of the user
	First *string `json:"first,omitempty"`
	// The last name of the user
	Last *string `json:"last,omitempty"`
	// The middle name of the user, if any
	Middle *string `json:"middle,omitempty"`
	// The suffix of the user, if any
	Suffix *string `json:"suffix,omitempty"`
}

// NewListUsersResponseUsersInnerName instantiates a new ListUsersResponseUsersInnerName object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewListUsersResponseUsersInnerName() *ListUsersResponseUsersInnerName {
	this := ListUsersResponseUsersInnerName{}
	return &this
}

// NewListUsersResponseUsersInnerNameWithDefaults instantiates a new ListUsersResponseUsersInnerName object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewListUsersResponseUsersInnerNameWithDefaults() *ListUsersResponseUsersInnerName {
	this := ListUsersResponseUsersInnerName{}
	return &this
}

// GetFirst returns the First field value if set, zero value otherwise.
func (o *ListUsersResponseUsersInnerName) GetFirst() string {
	if o == nil || IsNil(o.First) {
		var ret string
		return ret
	}
	return *o.First
}

// GetFirstOk returns a tuple with the First field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ListUsersResponseUsersInnerName) GetFirstOk() (*string, bool) {
	if o == nil || IsNil(o.First) {
		return nil, false
	}
	return o.First, true
}

// HasFirst returns a boolean if a field has been set.
func (o *ListUsersResponseUsersInnerName) HasFirst() bool {
	if o != nil && !IsNil(o.First) {
		return true
	}

	return false
}

// SetFirst gets a reference to the given string and assigns it to the First field.
func (o *ListUsersResponseUsersInnerName) SetFirst(v string) {
	o.First = &v
}

// GetLast returns the Last field value if set, zero value otherwise.
func (o *ListUsersResponseUsersInnerName) GetLast() string {
	if o == nil || IsNil(o.Last) {
		var ret string
		return ret
	}
	return *o.Last
}

// GetLastOk returns a tuple with the Last field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ListUsersResponseUsersInnerName) GetLastOk() (*string, bool) {
	if o == nil || IsNil(o.Last) {
		return nil, false
	}
	return o.Last, true
}

// HasLast returns a boolean if a field has been set.
func (o *ListUsersResponseUsersInnerName) HasLast() bool {
	if o != nil && !IsNil(o.Last) {
		return true
	}

	return false
}

// SetLast gets a reference to the given string and assigns it to the Last field.
func (o *ListUsersResponseUsersInnerName) SetLast(v string) {
	o.Last = &v
}

// GetMiddle returns the Middle field value if set, zero value otherwise.
func (o *ListUsersResponseUsersInnerName) GetMiddle() string {
	if o == nil || IsNil(o.Middle) {
		var ret string
		return ret
	}
	return *o.Middle
}

// GetMiddleOk returns a tuple with the Middle field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ListUsersResponseUsersInnerName) GetMiddleOk() (*string, bool) {
	if o == nil || IsNil(o.Middle) {
		return nil, false
	}
	return o.Middle, true
}

// HasMiddle returns a boolean if a field has been set.
func (o *ListUsersResponseUsersInnerName) HasMiddle() bool {
	if o != nil && !IsNil(o.Middle) {
		return true
	}

	return false
}

// SetMiddle gets a reference to the given string and assigns it to the Middle field.
func (o *ListUsersResponseUsersInnerName) SetMiddle(v string) {
	o.Middle = &v
}

// GetSuffix returns the Suffix field value if set, zero value otherwise.
func (o *ListUsersResponseUsersInnerName) GetSuffix() string {
	if o == nil || IsNil(o.Suffix) {
		var ret string
		return ret
	}
	return *o.Suffix
}

// GetSuffixOk returns a tuple with the Suffix field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ListUsersResponseUsersInnerName) GetSuffixOk() (*string, bool) {
	if o == nil || IsNil(o.Suffix) {
		return nil, false
	}
	return o.Suffix, true
}

// HasSuffix returns a boolean if a field has been set.
func (o *ListUsersResponseUsersInnerName) HasSuffix() bool {
	if o != nil && !IsNil(o.Suffix) {
		return true
	}

	return false
}

// SetSuffix gets a reference to the given string and assigns it to the Suffix field.
func (o *ListUsersResponseUsersInnerName) SetSuffix(v string) {
	o.Suffix = &v
}

func (o ListUsersResponseUsersInnerName) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o ListUsersResponseUsersInnerName) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.First) {
		toSerialize["first"] = o.First
	}
	if !IsNil(o.Last) {
		toSerialize["last"] = o.Last
	}
	if !IsNil(o.Middle) {
		toSerialize["middle"] = o.Middle
	}
	if !IsNil(o.Suffix) {
		toSerialize["suffix"] = o.Suffix
	}
	return toSerialize, nil
}

type NullableListUsersResponseUsersInnerName struct {
	value *ListUsersResponseUsersInnerName
	isSet bool
}

func (v NullableListUsersResponseUsersInnerName) Get() *ListUsersResponseUsersInnerName {
	return v.value
}

func (v *NullableListUsersResponseUsersInnerName) Set(val *ListUsersResponseUsersInnerName) {
	v.value = val
	v.isSet = true
}

func (v NullableListUsersResponseUsersInnerName) IsSet() bool {
	return v.isSet
}

func (v *NullableListUsersResponseUsersInnerName) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableListUsersResponseUsersInnerName(val *ListUsersResponseUsersInnerName) *NullableListUsersResponseUsersInnerName {
	return &NullableListUsersResponseUsersInnerName{value: val, isSet: true}
}

func (v NullableListUsersResponseUsersInnerName) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableListUsersResponseUsersInnerName) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


